#!/bin/bash

set -e

# you may set env var HELIROOT (helianthus repo)
# or HELIBUILDER (path to build-program-win.sh script from Helianthus)

set -e

ROOT="$(cd `dirname "$0"`; pwd)"
cd "$ROOT"

if [ -z "$HELIROOT" ]; then
	HELIROOT="$ROOT/../helianthus"
fi

if [ -z "$HELIBUILDER" ]; then
	HELIBUILDER="$HELIROOT/win/build-program-win.sh"
fi

FILES=`echo src/*.cpp src/*/*.cpp Box2D/*/*.cpp Box2D/*/*/*.cpp`

mkdir -p "$ROOT/build-win"

TARGETPATH="$ROOT/build-win" \
OPTIONS="-O3 -DNDEBUG -I$ROOT -I$ROOT/Box2D" \
COMPILER=c++ \
"$HELIBUILDER" mech2d $FILES

echo "... done ..."

