#!/bin/bash

set -e

ROOT="$(cd `dirname "$0"`; pwd)"
cd "$ROOT"

if [ "$1" = "fast" ] || [ "$1" = "fastdebug" ] ; then
	LIBS="helianthus box2d"
	FLAGS="-Wall"
	FILES=`echo src/*.cpp src/*/*.cpp`
else
	LIBS="helianthus"
	FLAGS="-Wall -I./Box2D"
	FILES=`echo src/*.cpp src/*/*.cpp Box2D/*/*.cpp Box2D/*/*/*.cpp`
fi


if [ "$1" = "debug" ] || [ "$1" = "fastdebug" ] ; then
	FLAGS="-O0 -g $FLAGS"
else
	FLAGS="-O3 -DNDEBUG $FLAGS"
fi


FLAGS="$FLAGS $(pkg-config --libs --cflags $LIBS)"


mkdir -p build
c++ $FLAGS $FILES -o build/mech2d

