
#include "motor.h"

Motor::Motor(Revolute &revolute, bool enabled, float speed):
	Child(revolute),
	revolute(revolute),
	radius(0.5f*revolute.world.motorWidth)
{
	setEnabled(enabled);
	setSpeed(speed);
}

Motor::~Motor()
	{ setSpeed(0); disable(); }

void Motor::setEnabled(bool enabled) {
	revolute.getJoint().EnableMotor(enabled);
	revolute.getJoint().SetMaxMotorTorque(enabled ? 100.f : 0.f);
}
bool Motor::getEnabled() const
	{ return revolute.getJoint().IsMotorEnabled(); }

void Motor::setSpeed(float speed)
	{ revolute.getJoint().SetMotorSpeed(speed); }
float Motor::getSpeed() const
	{ return revolute.getJoint().GetMotorSpeed(); }


void Motor::draw() const {
	const b2Vec2 pa = revolute.getJoint().GetAnchorA();
	const b2Vec2 pb = revolute.getJoint().GetAnchorB();
	saveState();
	noFill();
	circle(pa.x, pa.y, radius);
	circle(pb.x, pb.y, radius);
	restoreState();
}
