#ifndef OBJECTS_MOTOR_H
#define OBJECTS_MOTOR_H


#include "revolute.h"


class Motor: public World::Child {
public:
	Revolute &revolute;
	const float radius;

public:
	explicit Motor(Revolute &revolute, bool enabled = true, float speed = 1);
	~Motor();
	
	void setEnabled(bool enabled);
	bool getEnabled() const;
	
	void setSpeed(float speed);
	float getSpeed() const;

	void enable()
		{ setEnabled(true); }
	void enable(float speed)
		{ enable(); setSpeed(speed); }
	void disable()
		{ setEnabled(false); }
	
	void draw() const override;
};

#endif
