
#include "objects/stick.h"
#include "objects/stickstick.h"
#include "objects/motor.h"

#include "samples.h"


void Samples::chebyshev(World& world) {
	const float h = sqrtf(24);
	
	Stick *base   = new Stick(world,  0, 0, 3, 3, 0);
	Stick *rotorA = new Stick(world, -1, 0, 1, 1, 0);
	Stick *rotorB = new Stick(world,  1, 0, 1, 1, 0);
	
	StickStick *motor =
	new StickStick(*base, *rotorA, -1, 0);
	new StickStick(*base, *rotorB,  1, 0);
	new Motor(*motor);
	
	Stick *frameA = new Stick(world, -1, 0, 1, 1, 0);
	new StickStick(*rotorA, *frameA, -1, -1);
	new StickStick(*rotorB, *frameA, -1,  1);
	
	Stick *frameB = new Stick(world, 1, 0, 1, 1, 0);
	new StickStick(*rotorA, *frameB, 1, -1);
	new StickStick(*rotorB, *frameB, 1,  1);
	
	Stick *lambdaA0 = new Stick(world, 0, 0, -3, 4);
	Stick *lambdaA1 = new Stick(world, -3, 0, -1.5, 2);
	new StickStick(*rotorA, *lambdaA0);
	new StickStick(*base, *lambdaA1);
	new StickStick(*lambdaA0, *lambdaA1);
	
	Stick *lambdaB0 = new Stick(world, 0, 0, 3, 4);
	Stick *lambdaB1 = new Stick(world, 3, 0, 1.5, 2);
	new StickStick(*rotorB, *lambdaB0);
	new StickStick(*base, *lambdaB1);
	new StickStick(*lambdaB0, *lambdaB1);
	
	Stick *lambdaC0 = new Stick(world, -2, 0, -3, h);
	Stick *lambdaC1 = new Stick(world, -3, 0, -2.5, h/2);
	new StickStick(*rotorA, *lambdaC0);
	new StickStick(*base, *lambdaC1);
	new StickStick(*lambdaC0, *lambdaC1);
	
	Stick *lambdaD0 = new Stick(world, 2, 0, 3, h);
	Stick *lambdaD1 = new Stick(world, 3, 0, 2.5, h/2);
	new StickStick(*rotorB, *lambdaD0);
	new StickStick(*base, *lambdaD1);
	new StickStick(*lambdaD0, *lambdaD1);
	
	Stick *legA0 = new Stick(world, -3, 4, -3, -4);
	Stick *legA1 = new Stick(world,  3, 4,  3, -4);
	Stick *legA2 = new Stick(world, -3, -4, 3, -3);
	Stick *legA3 = new Stick(world, -3, -3, 3, -4);
	new StickStick(*legA2, *legA3);
	new StickStick(*legA0, *legA2);
	new StickStick(*legA0, *legA3);
	new StickStick(*legA1, *legA2);
	new StickStick(*legA1, *legA3);
	new StickStick(*lambdaA0, *legA0);
	new StickStick(*lambdaB0, *legA1);
	
	Stick *legB0 = new Stick(world, -3,  h, -3, h-8);
	Stick *legB1 = new Stick(world,  3,  h,  3, h-8);
	Stick *legB2 = new Stick(world, -3, h-8, 3, h-7);
	Stick *legB3 = new Stick(world, -3, h-7, 3, h-8);
	new StickStick(*legB2, *legB3);
	new StickStick(*legB0, *legB2);
	new StickStick(*legB0, *legB3);
	new StickStick(*legB1, *legB2);
	new StickStick(*legB1, *legB3);
	new StickStick(*lambdaC0, *legB0);
	new StickStick(*lambdaD0, *legB1);
}
