
#include "toolarrow.h"


ToolArrow::ToolArrow(Toolbox &toolbox):
	Tool(toolbox, "arrow"), body() { }

void ToolArrow::onDeselect()
	{ body = nullptr; }


bool ToolArrow::handleInput() {
	const double k = 10;
	double x = transformedMouseX();
	double y = transformedMouseY();
	
	if (body) {
		if (mouseWentUp("left"))
			{ body = nullptr; return true; }
		
		b2Vec2 p = body->GetWorldPoint(point);
		target = b2Vec2(x, y);
		b2Vec2 force( (target.x - p.x)*k, (target.y - p.y)*k );
		body->ApplyForce(force, p, false);
		return true;
	}
	
	if (mouseWentDown("left")) {
		const World::ChildrenList &list = world.getChildren();
		for(World::ChildrenList::const_reverse_iterator ri = list.rbegin(); ri != list.rend(); ++ri) {
			body = (*ri)->pickBody(x, y);
			if (body) {
				target = point = body->GetLocalPoint(b2Vec2(x, y));
				return true;
			}
		}
	}
	
	return false;
}


void ToolArrow::draw() const {
	if (body) {
		b2Vec2 p = body->GetWorldPoint(point);
		line(p.x, p.y, target.x, target.y);
	}
}

